/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/



/* #include "dist.h" */

typedef coord* rand_pt_f(coord *p, int dim, double rand_param);
	/* generate a random point, coords starting at p, of dimension dim,
		using parameter rand_param */


rand_pt_f
	rand_gauss_pt,	/* coordinates independent Gaussian
						of mean 0 and variance 1 */
	rand_laplace_pt,	/* independent laplace */
	rand_uniform_pt,	/* uniform in [0,1]^dim */
	rand_co_gauss_pt,	/* correlated gaussian coordinates */
	rand_co_laplace_pt;	/* correlated laplace coordinates */
