/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/


	/**************************************************************************
	*	user-supplied: given i and j, should return distance between 
	*		point i and point j;		
	***************************************************************************/

typedef float (*sb_distance)(size_t i, size_t j);

	/**************************************************************************
	*	user-supplied: given site i, return ``color'' of i, an integer,
	*		for classification
	***************************************************************************/

typedef size_t (*color_func)(size_t i);

typedef struct sb *sbp;

typedef struct SD {	/* some queries return SD*'s, for a set of sites */
    int point;		/* index of site */
    float key;		/* generally, distance between this site and query point */
} SD;

void free_sb(sbp);
